import { Injectable, ɵɵdefineInjectable, EventEmitter, Directive, ElementRef, Output, Input, HostListener, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Subject, fromEvent } from 'rxjs';
import { filter, distinctUntilChanged, debounceTime, takeUntil } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@service/mz-file-upload-service/\@res/\@abstract/\@enum/common.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const MzFileUploadTypeEnum = {
    drop: 1,
    input: 2,
    all: 3,
};
MzFileUploadTypeEnum[MzFileUploadTypeEnum.drop] = 'drop';
MzFileUploadTypeEnum[MzFileUploadTypeEnum.input] = 'input';
MzFileUploadTypeEnum[MzFileUploadTypeEnum.all] = 'all';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@service/mz-file-upload-service/mz-file-upload.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MzFileUploadService {
    constructor() {
        this.fileUpload$ = new Subject();
        this.fileOptions = {};
    }
    /**
     * get file
     *
     * @param {?=} options
     * @return {?}
     */
    getFile(options) {
        return this.fileUpload$.pipe(filter((/**
         * @param {?} item
         * @return {?}
         */
        item => {
            return !options ||
                ((!options.type || options.type === item.type) &&
                    (!options.id || options.id === item.id));
        })));
    }
    /**
     * update state of view
     *
     * @param {?} options
     * @param {?} state
     * @return {?}
     */
    updateStateOfView(options, state) {
        if (options && typeof options.id !== 'undefined') {
            /** @type {?} */
            const type = options.type || MzFileUploadTypeEnum.all;
            if (type === MzFileUploadTypeEnum.all) {
                /** @type {?} */
                const viewIdDrop = this.getViewIdWithType({
                    id: options.id,
                    type: MzFileUploadTypeEnum.drop
                });
                /** @type {?} */
                const viewIdInput = this.getViewIdWithType({
                    id: options.id,
                    type: MzFileUploadTypeEnum.input
                });
                this.fileOptions = Object.assign({}, this.fileOptions, { [viewIdInput]: Object.assign({}, (this.fileOptions[viewIdInput] || {}), { active: state }), [viewIdDrop]: Object.assign({}, (this.fileOptions[viewIdDrop] || {}), { active: state }) });
            }
            else {
                /** @type {?} */
                const viewId = this.getViewIdWithType(options);
                this.fileOptions = Object.assign({}, this.fileOptions, { [viewId]: Object.assign({}, (this.fileOptions[viewId] || {}), { active: state }) });
            }
            return true;
        }
        return false;
    }
    /**
     *
     *
     * @param {?} options
     * @return {?}
     */
    getStateOfView(options) {
        if (options && typeof options.id !== 'undefined') {
            /** @type {?} */
            const viewId = this.getViewIdWithType(options);
            /** @type {?} */
            const state = this.fileOptions[viewId] && this.fileOptions[viewId].active;
            return typeof state === 'boolean' ? state : true;
        }
    }
    /**
     *
     *
     * @private
     * @param {?} options
     * @return {?}
     */
    getViewIdWithType(options) {
        /** @type {?} */
        let viewId;
        /** @type {?} */
        let type;
        if (options && typeof options.id !== 'undefined') {
            type = options.type || MzFileUploadTypeEnum.all;
            viewId = `${options.id}-${type}`;
        }
        return viewId;
    }
    /**
     * upload file
     *
     * @param {?} file
     * @param {?} id
     * @param {?} type
     * @return {?}
     */
    upload(file, id, type) {
        this.fileUpload$.next({
            id: id,
            file: file,
            type: type
        });
    }
}
MzFileUploadService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ MzFileUploadService.ngInjectableDef = ɵɵdefineInjectable({ factory: function MzFileUploadService_Factory() { return new MzFileUploadService(); }, token: MzFileUploadService, providedIn: "root" });
if (false) {
    /** @type {?} */
    MzFileUploadService.prototype.fileUpload$;
    /** @type {?} */
    MzFileUploadService.prototype.fileOptions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@directrive/file-drop/file-drop.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FileDropDirective {
    /**
     * @param {?} mzFileDropServiceService
     * @param {?} el
     */
    constructor(mzFileDropServiceService, el) {
        this.mzFileDropServiceService = mzFileDropServiceService;
        this.el = el;
        /**
         * files droped
         *
         */
        this.mzFileUpload = new EventEmitter();
        /**
         * files droped
         *
         */
        this.filterEvent = this.filterEvent_;
        /**
         * file mz file drop active
         *
         */
        this.mzFileDropActive = true;
        /**
         * file mz file drop active
         *
         */
        this.mzFileDebounce = 100;
        /**
         * file hovered state
         *
         */
        this.mzFileHovered = new EventEmitter();
        this.onHover$ = new Subject();
        this.alive$ = new Subject();
    }
    /**
     *
     *
     * @private
     * @return {?}
     */
    get mzFileDropSmartActive() {
        /** @type {?} */
        const firstState = this.mzFileDropServiceService.getStateOfView({
            id: this.mzFileId,
            type: MzFileUploadTypeEnum.drop
        });
        return firstState && this.mzFileDropActive;
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onDrop($event) {
        $event.preventDefault();
        /** @type {?} */
        const transfer = $event.dataTransfer;
        /** @type {?} */
        const files = (/** @type {?} */ (transfer.files));
        if (this.filterEvent($event)) {
            this.mzFileUpload.emit(files);
            this.mzFileDropServiceService.upload(files, this.mzFileId, MzFileUploadTypeEnum.drop);
        }
        this.onHover$.next(false);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.onHover$
            .pipe(distinctUntilChanged(), debounceTime(this.mzFileDebounce), takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} state
         * @return {?}
         */
        state => {
            this.mzFileHovered.emit(state);
        }));
        fromEvent(document, 'dragover')
            .pipe(takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            /** @type {?} */
            const targetElement = event.target;
            /** @type {?} */
            const elementInside = this.el.nativeElement.contains(targetElement);
            if (elementInside) {
                event.preventDefault();
            }
            if (this.filterEvent(event)) {
                this.hoverEmit(elementInside);
            }
        }));
        fromEvent(document, 'dragleave')
            .pipe(takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} event
         * @return {?}
         */
        event => {
            this.hoverEmit(false);
        }));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.alive$.next(true);
        this.alive$.unsubscribe();
    }
    /**
     *
     *
     * @private
     * @param {?} $event
     * @return {?}
     */
    filterEvent_($event) {
        return $event.dataTransfer && $event.dataTransfer.files && $event.dataTransfer.files.length > 0;
    }
    /**
     *
     *
     * @private
     * @param {?} state
     * @return {?}
     */
    hoverEmit(state) {
        if (!this.mzFileDropSmartActive) {
            return;
        }
        this.onHover$.next(state);
    }
}
FileDropDirective.decorators = [
    { type: Directive, args: [{
                selector: '[mzFileDrop]'
            },] }
];
/** @nocollapse */
FileDropDirective.ctorParameters = () => [
    { type: MzFileUploadService },
    { type: ElementRef }
];
FileDropDirective.propDecorators = {
    mzFileUpload: [{ type: Output }],
    mzFileId: [{ type: Input }],
    filterEvent: [{ type: Input }],
    mzFileDropActive: [{ type: Input }],
    mzFileDebounce: [{ type: Input }],
    mzFileHovered: [{ type: Output }],
    onDrop: [{ type: HostListener, args: ['drop', ['$event'],] }]
};
if (false) {
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileUpload;
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileId;
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.filterEvent;
    /**
     * file mz file drop active
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileDropActive;
    /**
     * file mz file drop active
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileDebounce;
    /**
     * file hovered state
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileHovered;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.onHover$;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.alive$;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.mzFileDropServiceService;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.el;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@directrive/file-input/file-input.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FileInputDirective {
    /**
     * @param {?} mzFileDropServiceService
     */
    constructor(mzFileDropServiceService) {
        this.mzFileDropServiceService = mzFileDropServiceService;
        /**
         * files droped
         *
         */
        this.mzFileUpload = new EventEmitter();
        /**
         * file mz file active
         *
         */
        this.mzFileActive = true;
    }
    /**
     *
     *
     * @private
     * @return {?}
     */
    get mzFileSmartActive() {
        /** @type {?} */
        const firstState = this.mzFileDropServiceService.getStateOfView({
            id: this.mzFileId,
            type: MzFileUploadTypeEnum.input
        });
        return firstState && this.mzFileActive;
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onClick($event) {
        event.preventDefault();
        if (this.mzFileSmartActive) {
            this.input.click();
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        const input = (this.input = document.createElement('input'));
        input.type = 'file';
        input.onchange = (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            if (this.mzFileSmartActive) {
                /** @type {?} */
                const file = event.target.files;
                this.mzFileDropServiceService.upload(file, this.mzFileId, MzFileUploadTypeEnum.input);
                this.mzFileUpload.emit(file);
            }
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.input = null;
    }
}
FileInputDirective.decorators = [
    { type: Directive, args: [{
                selector: '[mzFileInput]'
            },] }
];
/** @nocollapse */
FileInputDirective.ctorParameters = () => [
    { type: MzFileUploadService }
];
FileInputDirective.propDecorators = {
    mzFileUpload: [{ type: Output }],
    mzFileId: [{ type: Input }],
    mzFileActive: [{ type: Input }],
    onClick: [{ type: HostListener, args: ['click', ['$event'],] }]
};
if (false) {
    /**
     * files droped
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileUpload;
    /**
     * files droped
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileId;
    /**
     * file mz file active
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileActive;
    /**
     * @type {?}
     * @private
     */
    FileInputDirective.prototype.input;
    /**
     * @type {?}
     * @private
     */
    FileInputDirective.prototype.mzFileDropServiceService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mz-file-upload.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MzFileUploadModule {
}
MzFileUploadModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [FileDropDirective, FileInputDirective],
                exports: [FileDropDirective, FileInputDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mz-file-upload.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MzFileUploadModule, MzFileUploadService, MzFileUploadTypeEnum, FileDropDirective as ɵa, FileInputDirective as ɵb };
//# sourceMappingURL=mz-file-upload.js.map
