import { Injectable, ɵɵdefineInjectable, EventEmitter, Directive, ElementRef, Output, Input, HostListener, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Subject, fromEvent } from 'rxjs';
import { filter, distinctUntilChanged, debounceTime, takeUntil } from 'rxjs/operators';
import { __assign } from 'tslib';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@service/mz-file-upload-service/\@res/\@abstract/\@enum/common.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var MzFileUploadTypeEnum = {
    drop: 1,
    input: 2,
    all: 3,
};
MzFileUploadTypeEnum[MzFileUploadTypeEnum.drop] = 'drop';
MzFileUploadTypeEnum[MzFileUploadTypeEnum.input] = 'input';
MzFileUploadTypeEnum[MzFileUploadTypeEnum.all] = 'all';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@service/mz-file-upload-service/mz-file-upload.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MzFileUploadService = /** @class */ (function () {
    function MzFileUploadService() {
        this.fileUpload$ = new Subject();
        this.fileOptions = {};
    }
    /**
     * get file
     * */
    /**
     * get file
     *
     * @param {?=} options
     * @return {?}
     */
    MzFileUploadService.prototype.getFile = /**
     * get file
     *
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return this.fileUpload$.pipe(filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return !options ||
                ((!options.type || options.type === item.type) &&
                    (!options.id || options.id === item.id));
        })));
    };
    /**
     * update state of view
     * */
    /**
     * update state of view
     *
     * @param {?} options
     * @param {?} state
     * @return {?}
     */
    MzFileUploadService.prototype.updateStateOfView = /**
     * update state of view
     *
     * @param {?} options
     * @param {?} state
     * @return {?}
     */
    function (options, state) {
        var _a, _b;
        if (options && typeof options.id !== 'undefined') {
            /** @type {?} */
            var type = options.type || MzFileUploadTypeEnum.all;
            if (type === MzFileUploadTypeEnum.all) {
                /** @type {?} */
                var viewIdDrop = this.getViewIdWithType({
                    id: options.id,
                    type: MzFileUploadTypeEnum.drop
                });
                /** @type {?} */
                var viewIdInput = this.getViewIdWithType({
                    id: options.id,
                    type: MzFileUploadTypeEnum.input
                });
                this.fileOptions = __assign({}, this.fileOptions, (_a = {}, _a[viewIdInput] = __assign({}, (this.fileOptions[viewIdInput] || {}), { active: state }), _a[viewIdDrop] = __assign({}, (this.fileOptions[viewIdDrop] || {}), { active: state }), _a));
            }
            else {
                /** @type {?} */
                var viewId = this.getViewIdWithType(options);
                this.fileOptions = __assign({}, this.fileOptions, (_b = {}, _b[viewId] = __assign({}, (this.fileOptions[viewId] || {}), { active: state }), _b));
            }
            return true;
        }
        return false;
    };
    /**
     *
     * */
    /**
     *
     *
     * @param {?} options
     * @return {?}
     */
    MzFileUploadService.prototype.getStateOfView = /**
     *
     *
     * @param {?} options
     * @return {?}
     */
    function (options) {
        if (options && typeof options.id !== 'undefined') {
            /** @type {?} */
            var viewId = this.getViewIdWithType(options);
            /** @type {?} */
            var state = this.fileOptions[viewId] && this.fileOptions[viewId].active;
            return typeof state === 'boolean' ? state : true;
        }
    };
    /**
     *
     * */
    /**
     *
     *
     * @private
     * @param {?} options
     * @return {?}
     */
    MzFileUploadService.prototype.getViewIdWithType = /**
     *
     *
     * @private
     * @param {?} options
     * @return {?}
     */
    function (options) {
        /** @type {?} */
        var viewId;
        /** @type {?} */
        var type;
        if (options && typeof options.id !== 'undefined') {
            type = options.type || MzFileUploadTypeEnum.all;
            viewId = options.id + "-" + type;
        }
        return viewId;
    };
    /**
     * upload file
     * */
    /**
     * upload file
     *
     * @param {?} file
     * @param {?} id
     * @param {?} type
     * @return {?}
     */
    MzFileUploadService.prototype.upload = /**
     * upload file
     *
     * @param {?} file
     * @param {?} id
     * @param {?} type
     * @return {?}
     */
    function (file, id, type) {
        this.fileUpload$.next({
            id: id,
            file: file,
            type: type
        });
    };
    MzFileUploadService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ MzFileUploadService.ngInjectableDef = ɵɵdefineInjectable({ factory: function MzFileUploadService_Factory() { return new MzFileUploadService(); }, token: MzFileUploadService, providedIn: "root" });
    return MzFileUploadService;
}());
if (false) {
    /** @type {?} */
    MzFileUploadService.prototype.fileUpload$;
    /** @type {?} */
    MzFileUploadService.prototype.fileOptions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@directrive/file-drop/file-drop.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileDropDirective = /** @class */ (function () {
    function FileDropDirective(mzFileDropServiceService, el) {
        this.mzFileDropServiceService = mzFileDropServiceService;
        this.el = el;
        /**
         * files droped
         *
         */
        this.mzFileUpload = new EventEmitter();
        /**
         * files droped
         *
         */
        this.filterEvent = this.filterEvent_;
        /**
         * file mz file drop active
         *
         */
        this.mzFileDropActive = true;
        /**
         * file mz file drop active
         *
         */
        this.mzFileDebounce = 100;
        /**
         * file hovered state
         *
         */
        this.mzFileHovered = new EventEmitter();
        this.onHover$ = new Subject();
        this.alive$ = new Subject();
    }
    Object.defineProperty(FileDropDirective.prototype, "mzFileDropSmartActive", {
        /**
         *
         * */
        get: /**
         *
         *
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var firstState = this.mzFileDropServiceService.getStateOfView({
                id: this.mzFileId,
                type: MzFileUploadTypeEnum.drop
            });
            return firstState && this.mzFileDropActive;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    FileDropDirective.prototype.onDrop = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        $event.preventDefault();
        /** @type {?} */
        var transfer = $event.dataTransfer;
        /** @type {?} */
        var files = (/** @type {?} */ (transfer.files));
        if (this.filterEvent($event)) {
            this.mzFileUpload.emit(files);
            this.mzFileDropServiceService.upload(files, this.mzFileId, MzFileUploadTypeEnum.drop);
        }
        this.onHover$.next(false);
    };
    /**
     * @return {?}
     */
    FileDropDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.onHover$
            .pipe(distinctUntilChanged(), debounceTime(this.mzFileDebounce), takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} state
         * @return {?}
         */
        function (state) {
            _this.mzFileHovered.emit(state);
        }));
        fromEvent(document, 'dragover')
            .pipe(takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var targetElement = event.target;
            /** @type {?} */
            var elementInside = _this.el.nativeElement.contains(targetElement);
            if (elementInside) {
                event.preventDefault();
            }
            if (_this.filterEvent(event)) {
                _this.hoverEmit(elementInside);
            }
        }));
        fromEvent(document, 'dragleave')
            .pipe(takeUntil(this.alive$))
            .subscribe((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            _this.hoverEmit(false);
        }));
    };
    /**
     * @return {?}
     */
    FileDropDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.alive$.next(true);
        this.alive$.unsubscribe();
    };
    /**
     *
     * */
    /**
     *
     *
     * @private
     * @param {?} $event
     * @return {?}
     */
    FileDropDirective.prototype.filterEvent_ = /**
     *
     *
     * @private
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        return $event.dataTransfer && $event.dataTransfer.files && $event.dataTransfer.files.length > 0;
    };
    /**
     *
     * */
    /**
     *
     *
     * @private
     * @param {?} state
     * @return {?}
     */
    FileDropDirective.prototype.hoverEmit = /**
     *
     *
     * @private
     * @param {?} state
     * @return {?}
     */
    function (state) {
        if (!this.mzFileDropSmartActive) {
            return;
        }
        this.onHover$.next(state);
    };
    FileDropDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[mzFileDrop]'
                },] }
    ];
    /** @nocollapse */
    FileDropDirective.ctorParameters = function () { return [
        { type: MzFileUploadService },
        { type: ElementRef }
    ]; };
    FileDropDirective.propDecorators = {
        mzFileUpload: [{ type: Output }],
        mzFileId: [{ type: Input }],
        filterEvent: [{ type: Input }],
        mzFileDropActive: [{ type: Input }],
        mzFileDebounce: [{ type: Input }],
        mzFileHovered: [{ type: Output }],
        onDrop: [{ type: HostListener, args: ['drop', ['$event'],] }]
    };
    return FileDropDirective;
}());
if (false) {
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileUpload;
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileId;
    /**
     * files droped
     *
     * @type {?}
     */
    FileDropDirective.prototype.filterEvent;
    /**
     * file mz file drop active
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileDropActive;
    /**
     * file mz file drop active
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileDebounce;
    /**
     * file hovered state
     *
     * @type {?}
     */
    FileDropDirective.prototype.mzFileHovered;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.onHover$;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.alive$;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.mzFileDropServiceService;
    /**
     * @type {?}
     * @private
     */
    FileDropDirective.prototype.el;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/\@directrive/file-input/file-input.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileInputDirective = /** @class */ (function () {
    function FileInputDirective(mzFileDropServiceService) {
        this.mzFileDropServiceService = mzFileDropServiceService;
        /**
         * files droped
         *
         */
        this.mzFileUpload = new EventEmitter();
        /**
         * file mz file active
         *
         */
        this.mzFileActive = true;
    }
    Object.defineProperty(FileInputDirective.prototype, "mzFileSmartActive", {
        /**
         *
         * */
        get: /**
         *
         *
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var firstState = this.mzFileDropServiceService.getStateOfView({
                id: this.mzFileId,
                type: MzFileUploadTypeEnum.input
            });
            return firstState && this.mzFileActive;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    FileInputDirective.prototype.onClick = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        event.preventDefault();
        if (this.mzFileSmartActive) {
            this.input.click();
        }
    };
    /**
     * @return {?}
     */
    FileInputDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var input = (this.input = document.createElement('input'));
        input.type = 'file';
        input.onchange = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (_this.mzFileSmartActive) {
                /** @type {?} */
                var file = event.target.files;
                _this.mzFileDropServiceService.upload(file, _this.mzFileId, MzFileUploadTypeEnum.input);
                _this.mzFileUpload.emit(file);
            }
        });
    };
    /**
     * @return {?}
     */
    FileInputDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.input = null;
    };
    FileInputDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[mzFileInput]'
                },] }
    ];
    /** @nocollapse */
    FileInputDirective.ctorParameters = function () { return [
        { type: MzFileUploadService }
    ]; };
    FileInputDirective.propDecorators = {
        mzFileUpload: [{ type: Output }],
        mzFileId: [{ type: Input }],
        mzFileActive: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click', ['$event'],] }]
    };
    return FileInputDirective;
}());
if (false) {
    /**
     * files droped
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileUpload;
    /**
     * files droped
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileId;
    /**
     * file mz file active
     *
     * @type {?}
     */
    FileInputDirective.prototype.mzFileActive;
    /**
     * @type {?}
     * @private
     */
    FileInputDirective.prototype.input;
    /**
     * @type {?}
     * @private
     */
    FileInputDirective.prototype.mzFileDropServiceService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mz-file-upload.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MzFileUploadModule = /** @class */ (function () {
    function MzFileUploadModule() {
    }
    MzFileUploadModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [FileDropDirective, FileInputDirective],
                    exports: [FileDropDirective, FileInputDirective]
                },] }
    ];
    return MzFileUploadModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mz-file-upload.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MzFileUploadModule, MzFileUploadService, MzFileUploadTypeEnum, FileDropDirective as ɵa, FileInputDirective as ɵb };
//# sourceMappingURL=mz-file-upload.js.map
