import { Observable, Subject } from 'rxjs';
import { MzFileDropInterface } from './@res/@abstract/@interface/common.interface';
import { MzFileUploadTypeEnum } from './@res/@abstract/@enum/common.enum';
export declare class MzFileUploadService {
    fileUpload$: Subject<MzFileDropInterface>;
    fileOptions: {
        [viewId: string]: {
            active: boolean;
        };
    };
    /**
     * get file
     * */
    getFile(options?: {
        id?: string | number;
        type?: MzFileUploadTypeEnum;
    }): Observable<MzFileDropInterface>;
    /**
     * update state of view
     * */
    updateStateOfView(options: {
        id: string | number;
        type?: MzFileUploadTypeEnum;
    }, state: boolean): boolean | undefined;
    /**
     *
     * */
    getStateOfView(options: {
        id: string | number;
        type: MzFileUploadTypeEnum;
    }): boolean | undefined;
    /**
     *
     * */
    private getViewIdWithType;
    /**
     * upload file
     * */
    upload(file: File[], id: string | number, type: MzFileUploadTypeEnum): void;
}
